<?php
/**
* This file is a part of the module message developed by Yov for the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/

/*
 * Modele des utilisateurs
 */
class MdlMessage extends MdlObject
{
	//Propriétés de base
	const moduleName="message";
	const objectType="message";
	const dbTable="ap_message";
	const isSelectable=true;
	const htmlEditorField="description";
	const hasAttachedFiles=true;

	
	//Propriétés d'IHM
	const nbObjectsByPage=50;
	
	//Champs Tri des résultats
	public static $sortFields=array("dateCrea@@asc","dateCrea@@desc","object@@asc","object@@desc");

	/*
		* RECUPERE ET AFFICHE LE NOM ET PRENOM DE L'EXPEDITEUR DU MESSAGE
	*/
	public function getNameFirstNameSender()
	{
			If(!empty($this->_idSender))
			{
			$Recipient_name=Db::getVal("SELECT name FROM ap_user WHERE _id=".$this->_idSender);
			$Recipient_Firstname=Db::getVal("SELECT firstName FROM ap_user WHERE _id=".$this->_idSender);
			return $Recipient_Firstname." ".$Recipient_name;
			}			
	}
	
	/*
		* RECUPERE ET AFFICHE LE NOM ET PRENOM DU DESTINATAIRE DU MESSAGE
	*/
	public function getNameFirstNameRecipient()
	{
			If(!empty($this->_idRecipient))
			{
			$Recipient_name=Db::getVal("SELECT name FROM ap_user WHERE _id=".$this->_idRecipient);
			$Recipient_Firstname=Db::getVal("SELECT firstName FROM ap_user WHERE _id=".$this->_idRecipient);
			return $Recipient_Firstname." ".$Recipient_name;
			}
	}
	
	/*
		* RECUPERE ET AFFICHE NOM ET PRENOM DES DESTINATIRES DU MESSAGE (OPTION : hideUser MASQUE L'UTILISATEUR EN COURS)
	*/
	public function getRecipients($option='')
	{
			// INFOS EXPEDITEURS/DESTINATAIRES
			If(!empty($this->_id))
			{
				// INIT
				$IdRecipients=null;
				$array_IdRecipients=array();
				$cpt=0;
				$InfoRecipients=null;
				$IdRecipients_tmp=null;
				
				$IdRecipients=Db::getVal("SELECT recipients FROM ap_message WHERE _id=".$this->_id);
				$array_IdRecipients=explode("@@",$IdRecipients);
				$punctation=false;
				
				foreach($array_IdRecipients as $IdRecipients_tmp)
				{
					// INIT
					$iconreader=null;
					$DateRead_tmp=null;
					
					$cpt++;
					if ($cpt!=1)
					{
						$InfoRecipient_tmp=Db::getVal("SELECT firstName FROM ".MdlUser::dbTable." WHERE _id=".$IdRecipients_tmp."")." ".Db::getVal("SELECT name FROM ap_user WHERE _id=".$IdRecipients_tmp."");
						$InfoRead_tmp=Db::getVal("SELECT `statuteRead` FROM ".MdlMessage::dbTable." WHERE `_idRecipient`=".$IdRecipients_tmp." AND `_idMessageSender`=".$this->_id." AND `_id`<>".$this->_id."");
						if ($InfoRead_tmp==1)
						{
							$DateRead_tmp=Db::getVal("SELECT `dateRead` FROM ".MdlMessage::dbTable." WHERE `_idRecipient`=".$IdRecipients_tmp." AND `_idMessageSender`=".$this->_id." AND `_id`<>".$this->_id."");
							$DateRead_tmp=Txt::formatDate($DateRead_tmp,"dbDatetime","inputDatetime");
							$iconreader=" <img title='Lu le : ".$DateRead_tmp." ' height='15px' src='app/img/message/readers.png'>";
						}
						if ($cpt==2)
						{
							if (($option=="hideUser") && ((Ctrl::$curUser->_id)==$IdRecipients_tmp))
							{$InfoRecipients='';$punctation=true;}
							else
							{$InfoRecipients=$InfoRecipient_tmp.$iconreader;}
						}
						elseif (($cpt>2)&&($cpt<6))
						{
							if (($option=="hideUser") && ((Ctrl::$curUser->_id)==$IdRecipients_tmp))
							{$InfoRecipients=$IdRecipients_tmp.$IdRecipients_tmp;}
							elseif($punctation==true){$InfoRecipients=$InfoRecipient_tmp.$iconreader;}
							elseif($punctation==false){$InfoRecipients=$InfoRecipients.", ".$InfoRecipient_tmp.$iconreader;}
						}
						else 
						{
							$InfoRecipients=$InfoRecipient_tmp.$iconreader."...";
						}
					}
				}
				return $InfoRecipients;
			}			
	}
	
	/*
		* COMPTE ET AFFICHE LE NOMBRE DE DESTINATAIRES
	*/
	public function getNbRecipients()
	{
			// RECUPERATION DU NOMBRE DE DESTINATAIRES (REPONDRE A TOUS)
			If(!empty($this->_id))
			{
				$Idrecipients=Db::getVal("SELECT `recipients` FROM ".MdlMessage::dbTable." WHERE `_id`=".$this->_id);
				$array_Idrecipients=explode("@@",$Idrecipients);
				$cpt=0;
				foreach($array_Idrecipients as $i)
				{$cpt++;}
				return $cpt-1;
			}			
	}
		
	/*
		* COMPTE ET AFFICHE LE NOMBRE DE LECTEURS
	*/
	public function getNbReaders()
	{
			// INFOS EXPEDITEURS/DESTINATAIRES
			If(!empty($this->_id))
			{
				$NbReaders=null;
				$NbRecipients=null;
				$NbReaders=count(Db::getTab("SELECT * FROM ".MdlMessage::dbTable." WHERE `_idMessageSender`=".$this->_id." AND `_id` <> ".$this->_id." AND `statuteRead`=1"));
				$NbRecipients=count(Db::getTab("SELECT * FROM ".MdlMessage::dbTable." WHERE `_idMessageSender`=".$this->_id." AND `_id` <> ".$this->_id.""));
				if($NbReaders==$NbRecipients){$spanClass="CircleGreen";} else {$spanClass="CircleRed";}
				return "<img src=\"app/img/message/readers.png\"><span class='".$spanClass." sLink' title=\"".$NbReaders." lecteur(s) sur ".$NbRecipients." \">".$NbReaders." </span>";
			}			
	}
	
	/*
		* COMPTE ET AFFICHE LE NOMBRE DES MESSAGES EN FONCTION DE TARGET
	*/
	public function getNbmessage($messagebox)
	{
			$statutebox=null;
			$idtmp=null;
			if($messagebox=='drafts'){$idtmp="_idSender=".Ctrl::$curUser->_id;$statutebox=0;}
			if($messagebox=='sendbox'){$idtmp="_idSender=".Ctrl::$curUser->_id;$statutebox=1;}
			if($messagebox=='inbox'){$idtmp="_idRecipient=".Ctrl::$curUser->_id; $statutebox=2;}
			//if($messagebox=='archives'){$idtmp="_idRecipient=".Ctrl::$curUser->_id." AND statute=3 OR _idSender=".Ctrl::$curUser->_id; $statutebox=3;}
			if($messagebox=='archives'){$idtmp="((`_idRecipient`=".Ctrl::$curUser->_id." AND `_id`<>`_idMessageSender`) OR (`_idSender`=".Ctrl::$curUser->_id." AND `_id`=`_idMessageSender`))";$statutebox=3;}
			if($messagebox=='bin'){$idtmp="((`_idRecipient`=".Ctrl::$curUser->_id." AND `_id`<>`_idMessageSender`) OR (`_idSender`=".Ctrl::$curUser->_id." AND `_id`=`_idMessageSender`))";$statutebox=4;}
			// INIT
			$nbinbox=null;
			// INFOS EXPEDITEURS/DESTINATAIRES
			$nbinbox=count(Db::getTab("SELECT * FROM ap_message WHERE ".$idtmp." AND statute=".$statutebox.""));
			return "(".$nbinbox.")";
	}
	
	/*
		* DIV POUR AFFICHAGE DES MESSAGES
	*/
	public function divMessage($specificClass=null, $specificAttributes=null)
	{
		// TARGET
		If (Req::isParam("target")) {$target=Req::Param("target");} else {$target="inbox";}
		$isSelectableclass=(static::isSelectable==true)  ?  "isSelectable"  :  null;
		$urlEdit="data-urlEdit=\"".$this->getUrl("edit")."&target=".$target."\"";
		return  "<div draggable='true' ondragstart='StartDrag(event)' ondragend='StopDrag(event)' class=\"objContainer ".$isSelectableclass." ".$specificClass."\" ".$specificAttributes." id=\"".$this->uniqId("objContainer")."\" for=\"".$this->uniqId("objMenu")."\" ".$urlEdit.">"; 
	}
	
	/*
	 * VUE : Menu de sélection d'objets (menu contextuel flottant)
	 */
	public static function menuSelectMessages()
	{
		$vDatas["curFolderIsWritable"]=(is_object(Ctrl::$curContainer) && Ctrl::$curContainer->editContentRight())  ?  true  :  false;
		$vDatas["rootFolderHasTree"]=($vDatas["curFolderIsWritable"]==true && count(Ctrl::getObj(get_class(Ctrl::$curContainer),1)->folderTree())>1)  ?  true  :  false;
		if(!empty(Req::Param("target")))	{$vDatas["target"]=Req::Param("target");}
		else{$vDatas["target"]="inbox";		}
		return Ctrl::getVue("app/ModMessage/VueMessageMenuSelection.php",$vDatas);
	}

	/*
		* VUE : Menu contextuel (édition, droit d'accès, etc)
		* $options =>  "inlineLauncher" (Bool : menu mini "burger")  &&  "deleteLabel" (label spécifique de suppression)  &&  "specificOptions" (options à ajouter au menu, cf. ci-dessous)
		* Exple de "specificOptions" =>  ["actionJs"=>"?ctrl=file&action=monAction", "iconSrc"=>"app/img/plus.png", "label"=>"mon option spécifique", "tooltip"=>"mon tooltip"]
	*/
	public function contextMessageMenu($options=null)
	{
		//	INIT  &  DIVERSES OPTIONS
		$vDatas["curObj"]=$this;
		if(!empty(Req::Param("target"))){$vDatas["target"]=Req::Param("target");}
		else{$vDatas["target"]="inbox";}
		$vDatas["specificOptions"]=(!empty($options["specificOptions"])) ? $options["specificOptions"] : array();
		//	AFFICHAGE DE LA PAGE
		return Ctrl::getVue("app/ModMessage/VueMessageMenuContext.php",$vDatas);
	}
	
	/*
		* VERIFIE SI L'USER EST IDENTIFIE ( OU INVITE/GUEST)
	*/
	public function isUser()
	{
		return (!empty($this->_id));
	}
	
	/*
		* SURCHARGE : DROIT D'ACCES AU MESSAGE
	*/
	public function accessRight()
	{
		//	INIT LA MISE EN CACHE
		if($this->_accessRight===null)
		{
			//	DROIT D'EDITION PAR DEFAUT POUR LES MESSAGE 
			$this->_accessRight=3;
		}
		return $this->_accessRight;
	}
}